config/routes.rb
Rails.application.routes.draw do

  get 'donationsmanager/menu'
  get 'donationsmanager/thanks'
  devise_for :users, controllers: { registrations: 'registrations'}
  root to: 'app#home'

  resources :profiles, only: [:show, :edit, :update], shallow: true do
    resources :images, except: :show
    resources :accounts, except: :show
    resources :beverages, only: [:new, :create]
  end

end

app/models/account.rb
class Account < ApplicationRecord
  belongs_to :profile
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/beverage.rb
class Beverage < ApplicationRecord
  belongs_to :profile
  has_one :donation, as: :donable
end

app/models/donation.rb
class Donation < ApplicationRecord
  belongs_to :donable, polymorphic: true
end

app/models/image.rb
class Image < ApplicationRecord
  belongs_to :profile
  has_one_attached :photo
end

app/models/profile.rb
class Profile < ApplicationRecord
  belongs_to :user
  has_one_attached :avatar
  has_many :accounts
  has_many :images
  has_many :beverages
  # has_many :hugs
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
  has_one :profile
end

app/controllers/accounts_controller.rb
class AccountsController < ApplicationController
  before_action :authenticate_user!
  before_action :set_profile, only: [:index, :new, :create]
  before_action :set_account, only: [:edit, :update, :destroy]

  before_action :check_current_user, only: [:index, :new]

  def index
    @accounts = @profile.accounts
  end

  def new
    @account = Account.new
  end

  def create
    @account = @profile.accounts.build(account_params)
    if @account.save
      redirect_to profile_accounts_path(@profile), notice: 'Account was successfully created.'
    else
      render :new
    end
  end

  def edit
  end

  def update
    @profile = @account.profile.id
    if @account.update(account_params)
      redirect_to profile_accounts_path(@profile), notice: 'Your info was successfully updated.'
    else
      render :edit
    end
  end

  def destroy
    @profile = @account.profile.id
    @account.destroy
    redirect_to profile_accounts_path(@profile), notice: 'Info was successfully destroyed.'
  end

  private

  def set_profile
    @profile = Profile.find(params[:profile_id])
  end

  def set_account
    @account = Account.find(params[:id])
  end

  def check_current_user
    if current_user.id != @profile.id
      redirect_to root_path
    end
  end

  def account_params
    params.require(:account).permit(:bank, :kind, :account_number, :email, :cedula)
  end
end

app/controllers/app_controller.rb
class AppController < ApplicationController
  def home
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception

  private

  def after_sign_in_path_for(resource)
    "/profiles/#{ current_user.profile.id }/edit"
  end
end

app/controllers/beverages_controller.rb
class BeveragesController < ApplicationController
  def new
    @profile = Profile.find(params[:profile_id])
    @beverage = Beverage.new
  end

  def create
    @profile = Profile.find(params[:profile_id])
    @beverage = @profile.beverages.build({quantity: params[:beverage][:quantity]})
    if @beverage.save
      @beverage.build_donation({
        occupation: params[:beverage][:occupation],
        message: params[:beverage][:message],
        contributor: params[:beverage][:contributor],
      }).save
      redirect_to donationsmanager_thanks_path(@profile), notice: 'Thank you for your donation!'
    else
      render :new
    end
  end
end

app/controllers/donationsmanager_controller.rb
class DonationsmanagerController < ApplicationController
  def menu
    @profile = Profile.find(params[:format])
  end

  def thanks
    @profile = Profile.find(params[:format])
  end
end

app/controllers/images_controller.rb
class ImagesController < ApplicationController
  before_action :authenticate_user!
  before_action :set_profile, only: [:index, :new, :create]
  before_action :set_image, only: [:edit, :update, :destroy]

  before_action :check_current_user, only: [:index, :new]

  def index
    @images = @profile.images
  end

  def new
    @image = Image.new
  end

  def create
    @image = @profile.images.build(image_params)
    if @image.save
      redirect_to profile_images_path(@profile), notice: 'image was successfully created.'
    else
      render :new
    end
  end

  def edit

  end

  def update
    @profile = @image.profile.id
    if @image.update(image_params)
      redirect_to profile_images_path(@profile), notice: 'Your info was successfully updated.'
    else
      render :edit
    end
  end

  def destroy
    @profile = @image.profile.id
    @image.destroy
    redirect_to profile_images_path(@profile), notice: 'Info was successfully destroyed.'
  end

  private

  def set_profile
    @profile = Profile.find(params[:profile_id])
  end

  def set_image
    @image = Image.find(params[:id])
  end

  def check_current_user
    if current_user.id != @profile.id
      redirect_to root_path
    end
  end

  def image_params
    params.require(:image).permit(:subtitle, :public, :photo)
  end
end

app/controllers/profiles_controller.rb
class ProfilesController < ApplicationController
  before_action :authenticate_user!, only: [:edit, :update]
  before_action :set_profile, only: [:edit, :update, :show]

  before_action :check_current_user, only: [:edit, :update]

  before_action :sort_me, only: [:update]

  def edit
  end

  def update
    if @profile.update(profile_params)
      @profile.update({
        m1: @multipliers[0],
        m2: @multipliers[1],
        m3: @multipliers[2],
        m4: @multipliers[3]
      })
      redirect_to edit_profile_path(@profile.id), notice: 'YES EDITED'
    else
      render :edit
    end
  end

  def show
  end

  private

  def sort_me
    @multipliers = []
    @multipliers << params[:profile][:m1].to_i
    @multipliers << params[:profile][:m2].to_i
    @multipliers << params[:profile][:m3].to_i
    @multipliers << params[:profile][:m4].to_i
    @multipliers.sort!
  end

  def set_profile
    @profile = Profile.find(params[:id])
  end

  def check_current_user
    if current_user.id != @profile.id
      redirect_to root_path
    end
  end

  def profile_params
    params.require(:profile).permit(:fullname, :bio, :occupation, :amount, :currency, :m1, :m2, :m3, :m4, :avatar)
  end
end

app/controllers/registrations_controller.rb
class RegistrationsController < Devise::RegistrationsController
  after_action :create_profile

  private

 def after_sign_up_path_for(resource)
   #but no! can't be the user id.....has to be the profile id
   "/profiles/#{ resource.id }/edit"
 end

 def create_profile
   if resource.persisted?
     @profile = resource.build_profile({
       fullname: "",
       occupation: "",
       bio: "",
       amount: "",
       m1: 1,
       m2: 2,
       m3: 3,
       m4: 5,
       currency: ""
     });
     @profile.save
   end
 end

end

app/helpers/accounts_helper.rb
module AccountsHelper
end

app/helpers/app_helper.rb
module AppHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/beverages_helper.rb
module BeveragesHelper
end

app/helpers/donationsmanager_helper.rb
module DonationsmanagerHelper
end

app/helpers/images_helper.rb
module ImagesHelper
end

app/helpers/profiles_helper.rb
module ProfilesHelper
end

app/helpers/registrations_helper.rb
module RegistrationsHelper
end

app/views/accounts/edit.html.haml
=render 'shared/admin_nav'
=link_to '< Listado de cuentas', profile_accounts_path(current_user.profile)
%h1 Editar Informacion de Cuenta

= form_with(model: @account, local: true) do |form|
  - if @account.errors.any?
    #error_explanation
      %h2
        = pluralize(@account.errors.count, "error")
        prohibited this profile from being saved:
      %ul
        - @account.errors.full_messages.each do |message|
          %li= message
  .field.form-group
    = form.label :bank, 'Banco'
    = form.text_field :bank, class: 'form-control'
  .field.form-group
    = form.label :kind, 'Tipo de cuenta'
    = form.text_field :kind, class: 'form-control'
  .field.form-group
    = form.label :account_number, 'Numero de cuenta'
    = form.text_field :account_number, class: 'form-control'
  .field.form-group
    = form.label :email, 'Email'
    = form.text_field :email, class: 'form-control'
  .field.form-group
    = form.label :cedula, 'RIF o cedula '
    = form.text_field :cedula, class: 'form-control'


  .actions
    = form.submit 'Guardar', class: 'btn btn-info btn-lg btn-block'

app/views/accounts/index.html.haml
=render 'shared/admin_nav'

%h1 Listado de cuentas

%table.table
  %p Cuentas
  %thead
    %tr
      %th Banco
      %th Tipo de cuenta
      %th Numero de cuenta
      %th Email
      %th{colspan: "3"}
  %tbody
    - @accounts.each do |account|
      %tr
        %td= account.bank
        %td= account.kind
        %td= account.account_number
        %td= account.email
        %td= link_to 'Editar', edit_account_path( account )
        %td= link_to 'Eliminar', account, method: :delete, data: { confirm: 'Are you sure?' }
%br/


= link_to 'Agregar', new_profile_account_path(@profile)

app/views/accounts/new.html.haml
=render 'shared/admin_nav'
=link_to '< Listado de cuentas', profile_accounts_path(@profile)


%p Datos de la cuenta
%p Parametros de la cuenta que han de mostrarse en el perfil publico

%h1 Agregar Cuenta

= form_with(model: [@profile, @account], local: true) do |form|
  - if @account.errors.any?
    #error_explanation
      %h2
        = pluralize(@account.errors.count, "error")
        prohibited this profile from being saved:
      %ul
        - @account.errors.full_messages.each do |message|
          %li= message
  .field.form-group
    = form.label :bank, 'Banco'
    = form.text_field :bank, class: 'form-control'
  .field.form-group
    = form.label :kind, 'Tipo de cuenta'
    = form.text_field :kind, class: 'form-control'
  .field.form-group
    = form.label :account_number, 'Numero de cuenta'
    = form.text_field :account_number, class: 'form-control'
  .field.form-group
    = form.label :email, 'Email'
    = form.text_field :email, class: 'form-control'
  .field.form-group
    = form.label :cedula, 'RIF o cedula '
    = form.text_field :cedula, class: 'form-control'


  .actions
    = form.submit 'Guardar', class: 'btn btn-info btn-lg btn-block'

app/views/beverages/new.html.haml
=render 'shared/public_nav'
=link_to '<Atras', :back

%p ¿Cuantos cafes?





= form_with(model: [@profile, @beverage], local: true) do |form|
  - if @beverage.errors.any?
    #error_explanation
      %h2
        = pluralize(@beverage.errors.count, "error")
        prohibited this profile from being saved:
      %ul
        - @beverage.errors.full_messages.each do |message|
          %li= message

  .field.form-group
    = form.label @profile.m1
    = form.radio_button :quantity, @profile.m1

    = form.label @profile.m2
    = form.radio_button :quantity, @profile.m2

    = form.label @profile.m3
    = form.radio_button :quantity, @profile.m3

    = form.label @profile.m4
    = form.radio_button :quantity, @profile.m4

    %hr
    %p=  "Datos de  " + @profile.fullname.split[0]
    -@profile.accounts.each do |account|
      %p= 'Entidad: ' + account.bank
      %p= 'Email: '+ account.email
      %p= 'Nro de cuenta: '+ account.account_number
      %p= 'Tipo de cuenta: '+ account.kind
      %p= 'RIF o cedula : '+ account.cedula
    %hr

    %p Tus datos
  .field.form-group
    = form.label :contributor, 'Nombre'
    = form.text_field :contributor, class: 'form-control'
  .field.form-group
    = form.label :occupation, 'Ocupacion'
    = form.text_field :occupation, class: 'form-control'
  .field.form-group
    = form.label :message, 'Mensaje de agradecimiento'
    = form.text_field :message, class: 'form-control'
    %hr

  .actions
    = form.submit '¡Listo! Notificar a ' + @profile.fullname.split[0], class: 'btn btn-info btn-lg btn-block'

app/views/images/edit.html.haml
=render 'shared/admin_nav'
=link_to '< Listado de imagenes', profile_images_path(current_user.profile)
%h1 Editar Image

%p Imagen del carousel
%p Editar imagen que se mostrara en el carousel del perfil publico

%p Datos de la imagen
%p Parametros de la publicacion y leyenda de la imagen a mostrarse en el carousel

= form_with(model: @image, local: true) do |form|
  - if @image.errors.any?
    #error_explanation
      %h2
        = pluralize(@image.errors.count, "error")
        prohibited this profile from being saved:
      %ul
        - @image.errors.full_messages.each do |message|
          %li= message
  .field.form-group
    = form.label :photo, 'Cargar imagen'
    = form.file_field :photo, class: 'form-control'
  .field.form-group
    = form.label :subtitle, 'Subtitulo'
    = form.text_field :subtitle, class: 'form-control'
  .field.form-group
    = form.label :public, 'Mostrar esta imagen en el perfil publico'
    = form.check_box :public, class: 'form-control'

  .actions
    = form.submit 'Guardar', class: 'btn btn-info btn-lg btn-block'


- begin
  =image_tag(@image.photo)
- rescue
  %p no image yet

app/views/images/index.html.haml
=render 'shared/admin_nav'
%h1 Carousel de imagenes

%table.table
  %p Imagenes
  %thead
    %tr
      %th
      %th
      %th{colspan: "4"}
  %tbody
    - @images.each do |image|
      %tr
        %td= image_tag(image.photo)
        %td= image.subtitle
        %td= link_to 'Editar', edit_image_path( image )
        %td= link_to 'Eliminar', image, method: :delete, data: { confirm: 'Are you sure?' }
%br/


= link_to 'Agregar', new_profile_image_path(@profile)

app/views/images/new.html.haml
=render 'shared/admin_nav'
=link_to '< Listado de imagenes', profile_images_path(@profile)
%h1 Agregar Imagen

%p Imagen del carousel
%p Agregar imagen que se mostrara en el carousel del perfil publico

%p Datos de la imagen
%p Parametros de la publicacion y leyenda de la imagen a mostrarse en el carousel

= form_with(model: [@profile, @image], local: true) do |form|
  - if @image.errors.any?
    #error_explanation
      %h2
        = pluralize(@image.errors.count, "error")
        prohibited this profile from being saved:
      %ul
        - @image.errors.full_messages.each do |message|
          %li= message
  .field.form-group
    = form.label :photo, 'Cargar imagen'
    = form.file_field :photo, class: 'form-control'
  .field.form-group
    = form.label :subtitle, 'Subtitulo'
    = form.text_field :subtitle, class: 'form-control'
  .field.form-group
    = form.label :public, 'Mostrar esta imagen en el perfil publico'
    = form.check_box :public, class: 'form-control'




  .actions
    = form.submit 'Guardar', class: 'btn btn-info btn-lg btn-block'

app/views/profiles/edit.html.haml
=render 'shared/admin_nav'
%h1 Perfil del usuario

= form_with(model: @profile, local: true) do |form|
  - if @profile.errors.any?
    #error_explanation
      %h2
        = pluralize(@profile.errors.count, "error")
        prohibited this profile from being saved:
      %ul
        - @profile.errors.full_messages.each do |message|
          %li= message
  .field.form-group
    = form.label :fullname, 'Nombre y Apellido'
    = form.text_field :fullname, class: 'form-control'
    .field.form-group
    = form.label :occupation, 'Ocupacion o rol'
    = form.text_field :occupation, class: 'form-control'
    .field.form-group
    = form.label :bio, 'Biografia'
    = form.hidden_field :bio, class: 'form-control', id: 'wys'
    %trix-editor.trix-editor{ input: 'wys'}
    %hr
    .field.form-group
    = form.label :amount, 'Monto de un cafe'
    = form.text_field :amount, class: 'form-control'
    .field.form-group
    = form.label :currency, 'Simbolo de la moneda'
    = form.text_field :currency, class: 'form-control'
    .field.form-group
    %p Multiplicadores

    = form.text_field :m1, class: 'form-control'

    = form.text_field :m2, class: 'form-control'

    = form.text_field :m3, class: 'form-control'

    = form.text_field :m4, class: 'form-control'
    %hr
    .field.form-group
    = form.label :avatar
    = form.file_field :avatar, class: 'dropify'

  .actions
    = form.submit 'Guardar', class: 'btn btn-info btn-lg btn-block'

app/views/profiles/show.html.haml
=render 'shared/public_nav'


%p= sanitize @profile.bio
%h2 Carousel Images:
- begin
  -@profile.images.each do |image|
    -if image.public
      =image_tag(image.photo)
      =image.subtitle
- rescue
  %p no images yet

%h2 Beverages donated to this profile
-@profile.beverages.each do |beverage|
  %p= beverage.quantity
  - begin
    %p= beverage.donation.message
    %p= beverage.donation.occupation
    %p= beverage.donation.contributor
    %hr
  - rescue
    %p no message here

%br


= link_to 'Dar abrazos o cafes a ' + @profile.fullname.split[0], donationsmanager_menu_path(@profile)